- block:
  - name: "Checks existing NetworkPolicy {{ policy_name }}"
    changed_when: False
    failed_when: False
    async: 30
    k8s_info:
      api_version: "{{ networkpolicy_apivers }}"
      kind: NetworkPolicy
      namespace: "{{ policy_namespace | default(namespace) }}"
      name: "{{ policy_name }}"
    no_log: True
    poll: 5
    register: ck_np
  - name: "Installs NetworkPolicy {{ policy_name }}"
    async: 30
    k8s:
      definition: "{{ lookup('template', 'network-policy.j2') }}"
      state: "{{ policy_state | default('present') }}"
    poll: 5
    when:
    - ck_np is defined
    - ck_np.resources is defined
    - >
        (ck_np.resources | length == 0)
        or (ck_np.resources | length > 0
            and ck_np.resources[0].metadata is defined
            and ck_np.resources[0].metadata['ownerReferences'] is defined
            and ck_np.resources[0].metadata['ownerReferences'][0]['apiVersion'] is defined
            and ck_np.resources[0].metadata['ownerReferences'][0]['apiVersion'] == cr_apivers
            and ck_np.resources[0].metadata['ownerReferences'][0]['kind'] is defined
            and ck_np.resources[0].metadata['ownerReferences'][0]['kind'] == cr_kind
            and ck_np.resources[0].metadata['ownerReferences'][0]['name'] is defined
            and ck_np.resources[0].metadata['ownerReferences'][0]['name'] == cr_name)
  when:
  - policy_name | default(False) not in [ False, 'False' ]
  - subject | default(False) not in [ False, 'False' ]
  - to | default(False) not in [ False, 'False' ]
